#!/usr/local/bin/python
# -*- coding: utf-8 -*-

import ssl
import sys
import urllib2
import urllib
import json
import re
from bs4 import BeautifulSoup
from urlparse import parse_qsl

import xbmc
import xbmcaddon
import xbmcgui
import xbmcplugin

_url = sys.argv[0]
_handle = int(sys.argv[1])
_addon = xbmcaddon.Addon()
_name = _addon.getAddonInfo('name')
_icon = _addon.getAddonInfo('icon')


def URL(action, link):
    u = _url + '?action=' + urllib2.quote(action)
    if link is not None:
        u += '&link=' + urllib2.quote(link)
    return u


MENU_ITEMS = []
DOMAIN = "https://www1.putlockers.co"
UA = 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/40.0.2214.85 Safari/537.36'
MAIN_MENU = [
    ("Movies", URL('list', DOMAIN + '/movies')),
    ("Top IMBd", URL('list', DOMAIN + '/topimdb')),
    ("TV Shows", URL('list', DOMAIN + '/tvseries')),
    ("New Episodes", URL('list', DOMAIN + '/episodes/')),
    ("Genre", URL('menu', 'genre')),
    ("Country", URL('menu', 'country')),
    ("Search", URL('find', None))
]

SUBMENUS = {
    'genre': [
        ("Action", URL('list', DOMAIN + '/genre/action/')),
        ("Adventure", URL('list', DOMAIN + '/genre/adventure/')),
        ("Animation", URL('list', DOMAIN + '/genre/animation/')),
        ("Biography", URL('list', DOMAIN + '/genre/biography/')),
        ("Comedy", URL('list', DOMAIN + '/genre/comedy/')),
        ("Crime", URL('list', DOMAIN + '/genre/crime/')),
        ("Documentary", URL('list', DOMAIN + '/genre/documentary/')),
        ("Drama", URL('list', DOMAIN + '/genre/drama/')),
        ("Family", URL('list', DOMAIN + '/genre/family/')),
        ("Fantasy", URL('list', DOMAIN + '/genre/fantasy/')),
        ("History", URL('list', DOMAIN + '/genre/history/')),
        ("Horror", URL('list', DOMAIN + '/genre/horror/')),
        ("Musical", URL('list', DOMAIN + '/genre/musical/')),
        ("Mystery", URL('list', DOMAIN + '/genre/mystery/')),
        ("Romance", URL('list', DOMAIN + '/genre/romance/')),
        ("Sci-Fi", URL('list', DOMAIN + '/genre/sci-fi/')),
        ("Sport", URL('list', DOMAIN + '/genre/sport/')),
        ("Thriller", URL('list', DOMAIN + '/genre/thriller/')),
        ("War", URL('list', DOMAIN + '/genre/war/'))
    ],
    'country': [
        ("Asia", URL('list', DOMAIN + '/country/"asia/')),
        ("China", URL('list', DOMAIN + '/country/china/')),
        ("Euro", URL('list', DOMAIN + '/country/euro/')),
        ("France", URL('list', DOMAIN + '/country/france/')),
        ("HongKong", URL('list', DOMAIN + '/country/hong kong/')),
        ("India", URL('list', DOMAIN + '/country/india/')),
        ("International", URL('list', DOMAIN + '/country/international/')),
        ("Japan", URL('list', DOMAIN + '/country/japan/')),
        ("Korea", URL('list', DOMAIN + '/country/korea/')),
        ("Taiwan", URL('list', DOMAIN + '/country/taiwan/')),
        ("Thailand", URL('list', DOMAIN + '/country/thailand/')),
        ("United Kingdom", URL('list', DOMAIN + '/country/uk/')),
        ("United States", URL('list', DOMAIN + '/country/us/'))
    ]
}


def new_menu_item(label, action, url, img=None, playable=False):
    item = xbmcgui.ListItem(label=label, thumbnailImage=img)
    if playable:
        item.setProperty('IsPlayable', 'true')
        xbmcplugin.addDirectoryItem(_handle, URL(action, url), listitem=item)
    else:
        MENU_ITEMS.append((URL(action, url), item, True))
    return item


def make_soup(url, params=None, raw=False, headers=None):
    xbmc.log("Requesting URL: " + url, 4)
    if params:
        paramsdata = urllib.urlencode(params)
        req = urllib2.Request(url, paramsdata)
    else:
        req = urllib2.Request(url)
    req.add_header('User-Agent', UA)
    for k, v in (headers or {}).items():
        req.add_header(k, v)
    resp = urllib2.urlopen(req, timeout=120)
    data = resp.read()

    result = data.decode('utf-8', 'ignore')
    if not raw:
        result = BeautifulSoup(result, "html.parser")
    resp.close()
    return result


def play_video(link):
    play_item = xbmcgui.ListItem(path=link)
    if link.startswith('https://streamango.com/embed/'):
        data = make_soup(link, raw=True, headers={
            'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8',
            'Accept-Language': 'en-US,en;q=0.5',
            'Cookie': '__cfduid=',
            'DNT': '1',
            'Connection': 'keep-alive',
            'Upgrade-Insecure-Requests': '1',
            'Pragma': 'no-cache',
            'Cache-Control': 'no-cache'
        })
        data = data[data.index('eval(function(p,a,c,k,e,r)'):]
        data = data[:data.index('</script>')]
        di = data.index('src:d')
        program = "window={};%s;print(window.%s);" % (data.split('\n')[0], data[di + 4:data.index(')', di) + 1])
        ans = make_soup("https://rextester.com/rundotnet/Run", params={
            "LanguageChoiceWrapper": "17",
            "EditorChoiceWrapper": "1",
            "LayoutChoiceWrapper": "1",
            "Program": program,
            "Input": "",
            "Privacy": "",
            "PrivacyUsers": "",
            "Title": "",
            "SavedOutput": "",
            "WholeError": "",
            "WholeWarning": "",
            "StatsToSave": "",
            "CodeGuid": "",
            "IsInEditMode": "False",
            "IsLive": "False"
        }, headers={
            "Referer": "https://rextester.com/l/js_online_compiler",
            "X-Requested-With": "XMLHttpRequest"
        }, raw=True)
        link = json.loads(ans)['Result'].strip()
        if link.startswith('//'):
            link = 'https:' + link
        play_item.setPath(link)
    xbmcplugin.setResolvedUrl(_handle, True, listitem=play_item)


def process_list(url):
    soup = make_soup(url)
    for video in soup.find_all('div', class_=['singleVideo']):
        title = video['title']
        url = video.find('a')['href']
        img = video.find('img')['src']
        tmp = video.find('span', class_='mli-quality')
        additional = None
        if tmp is not None:
            additional = tmp.getText()
        else:
            tmp = video.find('p', class_='seacsonInfo')
            if tmp is not None:
                additional = tmp.find('span').getText() + " Season"

        if additional:
            title = '%s [COLOR red]%s[/COLOR]' % (title, additional)
        info = video.find_all('div', class_=['jt-info'])
        year = info[1].getText().split('-')[0]
        plot = video.find('p', class_='f-desc').getText()

        info_labels = {'plot': plot}
        if str(year).isdigit():
            info_labels['year'] = year

        item = new_menu_item(title, 'video', url, img=img)
        item.setInfo(type="video", infoLabels=info_labels)
    pagination = soup.find('ul', class_='pagination')
    if pagination is None:
        return
    pagination_a = pagination.find_all('a')
    current = pagination.find_all('li', class_='active')[-1].getText()
    next_url = pagination_a[-1]['href']
    total = pagination_a[-2].getText()
    xbmc.log("Next URL: " + next_url, 4)
    new_menu_item('[COLOR blue]Page %d out of %s[/COLOR]' % (int(current) + 1, total), 'list', next_url)


def process_video(url):
    print "Processing video page"
    soup = make_soup(url)
    source = soup.find('a', class_=['thumb', 'mvi-cover'])
    if source is None:  # TV Series page
        if 'season' in url.split('/')[-1]:  # List episodes
            episodes = soup.find('div', class_='videosContainer').find_all('div', class_=['singleVideo'])
            for episode in episodes:
                title = episode.find('div', class_='tiptitle').getText()
                url = episode.find('a')['href']
                img = episode.find('img')['src']
                plot = episode.find('p', class_='f-desc').getText()
                item = new_menu_item(title, 'video', url, img=img)
                item.setInfo(type="video", infoLabels={'plot': plot})
        else:  # List seasons
            img = soup.find('div', class_='topdescriptionthumb').find('img')['src']
            plot = soup.find('div', class_='topdescriptiondesc').find('p').getText()
            for a in soup.find('div', class_='movies-letter').find_all('a'):
                item = new_menu_item('Season %s' % a.getText(), 'video', a['href'], img=img)
                item.setInfo(type="video", infoLabels={'plot': plot})
        return

    soup = make_soup(source['href'])
    source = soup.find('iframe')['src']
    js_mess = str(make_soup(source, raw=True))

    """
     Extracting mirrors
    """
    tcs = js_mess.index('var tc = ')
    tce = js_mess[tcs:].index('</script>')
    mirror_data = js_mess[tcs:tcs + tce]
    mirror_token = re.findall(r"\"_token\": \"([0-9A-Za-z].+)\"", mirror_data)[0]
    mirror_te = re.findall(r"var tc = '([0-9A-Za-z].+)'", mirror_data)[0]
    mirror_p = re.findall(r"\.slice\((\d+),(\d+)\).+\"(\d+)\"\+\"(\d+)\";", mirror_data)[0]
    mirror_xtoken = mirror_te[int(mirror_p[0]):int(mirror_p[1])][::-1] + mirror_p[2] + mirror_p[3]
    mirror_json = make_soup('https://gomostream.com/decoding_v3.php', raw=True,
                            params={
                                '_token': mirror_token,
                                'tokenCode': mirror_te
                            },
                            headers={
                                'x-token': mirror_xtoken
                            })
    xbmc.log("Token %s, TE: %s, xtoken: %s, JSON: %s" % (mirror_token, mirror_te, mirror_xtoken, mirror_json), 4)
    mirrors = json.loads(mirror_json)
    for i, mirror in enumerate(mirrors):
        for available in {'https://gomostream.com/vid/?v', 'https://streamango.com/embed/'}:
            if mirror.startswith(available):
                new_menu_item("Mirror %d" % (i + 1), 'play', mirror, playable=True)


def list_link(link=None, additional=None):
    listing = []
    if link is None:
        list_item = xbmcgui.ListItem(label="Search")
        listing.append((_url + "?action=search", list_item, True))
    xbmcplugin.addDirectoryItems(_handle, listing, len(listing))
    xbmcplugin.endOfDirectory(_handle)


def router(paramstring):
    xbmc.log("Router: " + paramstring, 4)
    params = dict(parse_qsl(paramstring))
    if params:
        if params['action'] == 'list':
            process_list(urllib2.unquote(params['link']))

        elif params['action'] == 'video':
            process_video(urllib2.unquote(params['link']))

        elif params['action'] == 'play':
            play_video(urllib2.unquote(params['link']))

        elif params['action'] == 'menu':
            for name, url in SUBMENUS.get(params['link'], []):
                item = xbmcgui.ListItem(label=name)
                MENU_ITEMS.append((url, item, True))

        elif params['action'] == 'find':
            text = xbmcgui.Dialog().input('Searching...')
            process_list(DOMAIN + '/topimdb?s=' + urllib.quote_plus(text.strip()))

    else:
        for name, url in MAIN_MENU:
            item = xbmcgui.ListItem(label=name)
            MENU_ITEMS.append((url, item, True))
    xbmcplugin.addDirectoryItems(_handle, MENU_ITEMS, len(MENU_ITEMS))
    xbmcplugin.endOfDirectory(_handle)


if __name__ == '__main__':
    try:
        router(sys.argv[2][1:])
    except urllib2.HTTPError as e:
        xbmcgui.Dialog().notification(_name, "Connection error {}".format(e.code))

    except urllib2.URLError as e:
        xbmcgui.Dialog().notification(_name, "Unable to connect", str(e.reason))

    except ssl.SSLError as e:
        if e.message == 'The read operation timed out':
            xbmcgui.Dialog().notification(_name, "Putlockers.co server timeout", "Try again later",
                                          icon=xbmcgui.NOTIFICATION_ERROR)
        else:
            xbmcgui.Dialog().notification(_name, "Connection error!", e.message)

    # except static.UpdateException as e:
    #     xbmcgui.Dialog().notification(_name, "Page error", e.message)
